Index: /gs3-extensions/testing/trunk/src/src/gstests/tutorials/RunGLITest.java
===================================================================
--- /gs3-extensions/testing/trunk/src/src/gstests/tutorials/RunGLITest.java	(revision 32692)
+++ /gs3-extensions/testing/trunk/src/src/gstests/tutorials/RunGLITest.java	(revision 32693)
@@ -23,4 +23,11 @@
 API:
 https://joel-costigliola.github.io/assertj/swing/api/index.html
+
+JUNIT:
+- https://junit.org/junit4/faq.html#atests_2
+   How do I use a test fixture?
+- https://junit.org/junit4/faq.html#organize_3
+   How can I run setUp() and tearDown() code once for all of my tests?
+
 */
 
@@ -121,14 +128,4 @@
       String expectedWindowTitle = Gatherer.PROGRAM_NAME;
 
-   
-      // https://joel-costigliola.github.io/assertj/assertj-swing-launch.html      
-      /*window = findFrame(new GenericTypeMatcher<JFrame>(JFrame.class) {
-	      protected boolean isMatching(JFrame window) {
-		  return window.getTitle().trim().startsWith(expectedWindowTitle)
-		  && window.isShowing();
-	      }
-	  }).using(robot());
-      */
-
       window = findFrame("GUIManager").using(robot());
       	
@@ -137,29 +134,7 @@
 
 	System.err.println("@@@ Second test: that Gather panel is selected and has right title");
-	
-	/*GenericTypeMatcher<JTabbedPane> textMatcher = new GenericTypeMatcher<JTabbedPane>(JTabbedPane.class) {
-		@Override protected boolean isMatching(JTabbedPane tabPane) {
-		    int index = GuiActionRunner.execute(() -> tabPane.getSelectedIndex());
-		    //int index = tabPane.getSelectedIndex();
-		    String selectedTabTitle = GuiActionRunner.execute(() -> tabPane.getTitleAt(index));
-		    System.err.println("### GOT TITLE: " + selectedTabTitle);
-		    return gatherPaneLabel.equals(selectedTabTitle);
-		}
-	    };
-	*/
 
 	JTabbedPaneFixture tab = window.tabbedPane("GUIManager.tab_pane");
-	/*
-	JTabbedPaneFixture tab = window.tabbedPane(new GenericTypeMatcher<JTabbedPane>(JTabbedPane.class) {
-		@Override protected boolean isMatching(JTabbedPane tabPane) {
-		    System.err.println("### trying for match");
-		    //int index = GuiActionRunner.execute(() -> tabPane.getSelectedIndex());
-		    int index = tabPane.getSelectedIndex();
-		    String selectedTabTitle = tabPane.getTitleAt(index); //GuiActionRunner.execute(() -> tabPane.getTitleAt(index));
-		    System.err.println("### GOT TITLE: " + selectedTabTitle);
-		    return gatherPaneLabel.equals(selectedTabTitle);
-		}
-	    });
-	*/
+
 	
 	tab.requireSelectedTab(Index.atIndex(1));
Index: /gs3-extensions/testing/trunk/src/src/org/greenstone/gsdl3/testing/GSGUITestingUtil.java
===================================================================
--- /gs3-extensions/testing/trunk/src/src/org/greenstone/gsdl3/testing/GSGUITestingUtil.java	(revision 32692)
+++ /gs3-extensions/testing/trunk/src/src/org/greenstone/gsdl3/testing/GSGUITestingUtil.java	(revision 32693)
@@ -110,3 +110,26 @@
     }
 
+    // Moving these working bits of code here, in case I can use them to right
+    // general get methods that make use of the GenericTypeMatcher method of accessing components
+    // See https://joel-costigliola.github.io/assertj/assertj-swing-lookup.html
+
+    /*window = findFrame(new GenericTypeMatcher<JFrame>(JFrame.class) {
+	      protected boolean isMatching(JFrame window) {
+		  return window.getTitle().trim().startsWith(expectedWindowTitle)
+		  && window.isShowing();
+	      }
+	  }).using(robot());
+      */
+    /*
+	JTabbedPaneFixture tab = window.tabbedPane(new GenericTypeMatcher<JTabbedPane>(JTabbedPane.class) {
+		@Override protected boolean isMatching(JTabbedPane tabPane) {
+		    System.err.println("### trying for match");
+		    //int index = GuiActionRunner.execute(() -> tabPane.getSelectedIndex());
+		    int index = tabPane.getSelectedIndex();
+		    String selectedTabTitle = tabPane.getTitleAt(index); //GuiActionRunner.execute(() -> tabPane.getTitleAt(index));
+		    System.err.println("### GOT TITLE: " + selectedTabTitle);
+		    return gatherPaneLabel.equals(selectedTabTitle);
+		}
+	    });
+    */
 }