Index: gs3-extensions/testing/trunk/src/src/gstests/tutorials/RunGLITest.java
===================================================================
--- gs3-extensions/testing/trunk/src/src/gstests/tutorials/RunGLITest.java	(revision 32705)
+++ gs3-extensions/testing/trunk/src/src/gstests/tutorials/RunGLITest.java	(revision 32713)
@@ -129,4 +129,6 @@
       window = findFrame("GUIManager").using(robot());
       
+      GSGUITestingUtil.setWindow(window); // set this first before calling any of Util's other methods
+      
       String gatherPaneLabel = Dictionary.get("GUI.Gather");
       System.err.println("@@@ Expecting label: " + gatherPaneLabel);
@@ -142,32 +144,32 @@
       // attempt to switch to enrich pane, uses static methods of GSGUITestingUtil
       // through static import of that class
-      switchToPane(window, DOWNLOAD_PANE);
+      switchToPane(DOWNLOAD_PANE);
 
       // For testing, want GLI to be in librarian mode by default
-      changeUserMode(window, "librarian");
+      changeUserMode("librarian");
 
-      switchToPane(window, GATHER_PANE);
+      switchToPane(GATHER_PANE);
       
-      loadCollection(window, "lucene-jdbm-demo");
+      loadCollection("lucene-jdbm-demo");
 
       // wait a couple of seconds again?
       PAUSE(2);      
-      closeCollection(window);
+      closeCollection();
       
-      createCollection(window, "pinky", "Pinky was here", null);
-      closeCollection(window); // collection must be closed in order to be deleted
-      deleteCollection(window, "pinky");
+      createCollection("pinky", "Pinky was here", null);
+      closeCollection(); // collection must be closed in order to be deleted
+      deleteCollection("pinky");
       // wait a few of seconds again?
       PAUSE(2);
       
-      exportCollection(window, "GreenstoneMETS", "lucene-jdbm-demo");
+      exportCollection("GreenstoneMETS", "lucene-jdbm-demo");
 
       // Reset GLI to expert mode for regular GLI use
-      changeUserMode(window, "expert");
+      changeUserMode("expert");
       
       PAUSE(5);
-      //exitGLI(window);
+      //exitGLI();
       
-      switchToPane(window, GATHER_PANE);
+      switchToPane(GATHER_PANE);
   }
 
Index: gs3-extensions/testing/trunk/src/src/org/greenstone/gsdl3/testing/GSGUITestingUtil.java
===================================================================
--- gs3-extensions/testing/trunk/src/src/org/greenstone/gsdl3/testing/GSGUITestingUtil.java	(revision 32705)
+++ gs3-extensions/testing/trunk/src/src/org/greenstone/gsdl3/testing/GSGUITestingUtil.java	(revision 32713)
@@ -23,4 +23,6 @@
 public class GSGUITestingUtil
 {
+    public static FrameFixture window = null;
+    
     public static final boolean PAUSE_ON = true;
     
@@ -33,5 +35,5 @@
     public static final String CREATE_PANE = "Create"; 
     public static final String FORMAT_PANE = "Format";
-
+    
     
     /************** NEEDED FOR TESTING *************/
@@ -41,4 +43,7 @@
 
     /************************ GENERAL *******************************/
+
+    public static void setWindow(FrameFixture w) { window = w; }
+    
     public static void PAUSE() {	
 	PAUSE(5);
@@ -57,5 +62,5 @@
     
     //https://joel-costigliola.github.io/assertj/swing/api/org/assertj/swing/fixture/FrameFixture.html
-    public static void switchToPane(FrameFixture window, String pane) {
+    public static void switchToPane(String pane) {
 	String paneLabel = Dictionary.get("GUI." + pane); // e.g. GUI.Enrich
 	//JPanelFixture tab = window.panel(pane); // this just gets us the JPanel of controls within
@@ -63,5 +68,5 @@
 	tab.selectTab(paneLabel); // select tab by its title
     }
-    public static void openMenuItem(FrameFixture window, String menu, String subMenu) {
+    public static void openMenuItem(String menu, String subMenu) {
 	/*String menuLabel = Dictionary.get("Menu." + menu); // e.g. Menu.File
 	window.menuItem(menuLabel).click(); //JMenuItemFixture.click()
@@ -73,5 +78,5 @@
 
     /*
-    public static void stealAnyLock(FrameFixture window) {
+    public static void stealAnyLock() {
 	DialogFixture dialog = window.dialog("LockFileDialog");
 	if(dialog != null) {
@@ -86,6 +91,6 @@
     
     /**********************FILE MENU*******************************/
-    public static void setPrefs(FrameFixture window, String tab, Map params) {
-	openMenuItem(window, "file", "options");
+    public static void setPrefs(String tab, Map params) {
+	openMenuItem("file", "options");
 
     }
@@ -95,6 +100,6 @@
      * Choose from Preferences.Mode.Assistant, Preferences.Mode.Librarian, Preferences.Mode.Expert
      */
-    public static void changeUserMode(FrameFixture window, String toMode) {
-	openMenuItem(window, "file", "options"); // click MenuBar.file -> MenuBar.file_options
+    public static void changeUserMode(String toMode) {
+	openMenuItem("file", "options"); // click MenuBar.file -> MenuBar.file_options
 
 	// switch to Mode tab
@@ -117,16 +122,16 @@
     }
 
-    public static void exitGLI(FrameFixture window) {
-	openMenuItem(window, "file", "exit");
+    public static void exitGLI() {
+	openMenuItem("file", "exit");
 	PAUSE(5);
     }
     
-    public static void closeCollection(FrameFixture window){
+    public static void closeCollection(){
 	// Through componennt names, clicks on MenuBar.file then MenuBar.file_close
-	openMenuItem(window, "file", "close");
-    }
-
-    public static void deleteCollection(FrameFixture window, String collName) {
-	openMenuItem(window, "file", "delete");
+	openMenuItem("file", "close");
+    }
+
+    public static void deleteCollection(String collName) {
+	openMenuItem("file", "delete");
 	DialogFixture dialog = window.dialog("DeleteCollectionPrompt"); // could call window.dialg() too as there will be only one, unless GLI run in debug mode?
 	
@@ -147,12 +152,11 @@
     }
     
-    public static void saveCollection(FrameFixture window) {
-	openMenuItem(window, "file", "save"); // MenuBar.file -> MenuBar.file_save
-    }
-
-    public static void createCollection(FrameFixture window,
-					String collTitle, String collDescription, String baseColl)
+    public static void saveCollection() {
+	openMenuItem("file", "save"); // MenuBar.file -> MenuBar.file_save
+    }
+
+    public static void createCollection(String collTitle, String collDescription, String baseColl)
     {
-	openMenuItem(window, "file", "new");
+	openMenuItem("file", "new");
 	DialogFixture dialog = window.dialog("col"); // GLI is unable to setName() of this dialog
 	// to NewCollectioNDetailsPrompt. Not sure why.
@@ -174,6 +178,6 @@
     }
 
-    public static void loadCollection(FrameFixture window, String collName) {
-	openMenuItem(window, "file", "open");
+    public static void loadCollection(String collName) {
+	openMenuItem("file", "open");
 	DialogFixture dialog = window.dialog("OpenCollectionDialog");
 	JListFixture collection_list = dialog.list("OpenCollectionDialog.collection_list");
@@ -220,7 +224,7 @@
      * not public collection name like "Demo Collection".
      */
-    public static void exportCollection(FrameFixture window, String exportToFormat, String exportColl)
+    public static void exportCollection(String exportToFormat, String exportColl)
     {
-	openMenuItem(window, "file", "exportas"); // Clicks MenuBar.file -> MenuBar.file_exportas
+	openMenuItem("file", "exportas"); // Clicks MenuBar.file -> MenuBar.file_exportas
 
 	DialogFixture dialog = window.dialog("ExportAsPrompt");	